cgroup	GROUP	code_seg, data_seg
	ASSUME	cs:cgroup, ds:cgroup
code_seg SEGMENT PUBLIC
;
; ⥭ ᥪ
	PUBLIC	read_sector
data_seg SEGMENT PUBLIC
	EXTRN	sector:BYTE
	EXTRN	disk_drive_no:BYTE
	EXTRN	current_sector_no:WORD
data_seg ENDS
read_sector	 PROC	NEAR
	push	ax
	push	bx
	push	cx
	push	dx
	mov	al,disk_drive_no
	mov	cx,1
	mov	dx,current_sector_no
	lea	bx,sector
	int	25h
	popf
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
read_sector ENDP
;
;  ᥪ
	PUBLIC	write_sector
	EXTRN	write_prompt_line:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	editor_prompt:BYTE
access_string	DB	'  ᥪ  '
		DB	'  shift+F5 ',0
data_seg ENDS
write_sector  PROC   NEAR
	push	ax
	push	bx
	push	cx
	push	dx
	lea	dx,access_string
	call	write_prompt_line
	mov	ah,8
	int	21h
	or	al,al
	jnz	write_error
	int	21h
	cmp	al,88
	jne	write_error
	mov	al,disk_drive_no
	mov	cx,1
	mov	dx,current_sector_no
	lea	bx,sector
	int	26h
	popf
write_error:
	lea	dx,editor_prompt
	call	write_prompt_line
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
write_sector ENDP
;
; ⠭ ᪮
	PUBLIC	new_drive
	EXTRN	write_prompt_line:NEAR
data_seg SEGMENT PUBLIC
string2	DB	'  ᪮, [A/B]: ',0
	EXTRN	disk_drive_no:BYTE
	EXTRN	current_sector_no:WORD
	EXTRN	editor_prompt:BYTE
data_seg ENDS
new_drive  PROC   NEAR
	push	ax
	push	dx
	lea	dx,string2
	call	write_prompt_line
	mov	ah,8
	int	21h
	or	al,al
	jnz	disk_no_1
	int	21h
	jmp	SHORT disk_no
disk_no_1:
	cmp	al,'a'
	je	disk_0
	cmp	al,'A'
	je	disk_0
	cmp	al,'b'
	je	disk_1
	cmp	al,'B'
	je	disk_1
	jmp	SHORT disk_no
disk_0:	xor	al,al
	jmp	SHORT disk_ok
disk_1:	mov	al,1
disk_ok:
	mov	disk_drive_no,al
	mov	current_sector_no,1
	call	previous_sector
disk_no:
	lea	dx,editor_prompt
	call	write_prompt_line
	pop	dx
	pop	ax
	ret
new_drive endp
;
;  ᥪ  筮    ⥭
	PUBLIC	sector_decimal
	EXTRN	write_prompt_line:NEAR
	EXTRN	read_decimal:NEAR
data_seg SEGMENT PUBLIC
string1	DB	'  ᥪ: ',0
	EXTRN	current_sector_no:WORD
	EXTRN	editor_prompt:BYTE
data_seg ENDS
sector_decimal PROC NEAR
	push	ax
	push	dx
	lea	dx,string1
	call	write_prompt_line
	call	read_decimal
	jc	s_dec_err
	mov	current_sector_no,ax
	call	read_sector
	call	init_sec_disp
s_dec_err:
	call	write_header
	lea	dx,editor_prompt
	call	write_prompt_line
	pop	dx
	pop	ax
	ret
sector_decimal endp
;
; ⥭ ।饣 ᥪ
	PUBLIC	previous_sector
	EXTRN	init_sec_disp:NEAR
	EXTRN	write_header:NEAR
	EXTRN	write_prompt_line:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	current_sector_no:WORD
	EXTRN	editor_prompt:BYTE
data_seg ENDS
previous_sector PROC NEAR
	push	ax
	push	dx
	mov	ax,current_sector_no
	or	ax,ax
	jz	dont_decrement_sector
	dec	ax
	mov	current_sector_no,ax
	call	write_header
	call	read_sector
	call	init_sec_disp
	lea	dx,editor_prompt
	call	write_prompt_line
dont_decrement_sector:
	pop	dx
	pop	ax
	ret
previous_sector ENDP
;
; ⥭ ᫥饣 ᥪ
	PUBLIC	next_sector
	EXTRN 	init_sec_disp:NEAR
	EXTRN	write_header:NEAR
	EXTRN	write_prompt_line:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	current_sector_no:WORD
	EXTRN	editor_prompt:BYTE
data_seg ENDS
next_sector PROC NEAR
	push	ax
	push	dx
	mov	ax,current_sector_no
	inc	ax
	mov	current_sector_no,ax
	call	write_header
	call	read_sector
	call	init_sec_disp
	lea	dx,editor_prompt
	call	write_prompt_line
	pop	dx
	pop	ax
	ret
next_sector ENDP
code_seg ENDS
	END